Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.ComponentModel.Design
Imports System.Windows.Forms

<Designer("System.Windows.Forms.Design.ParentControlDesigner,System.Design", GetType(IDesigner))> _
Public NotInheritable Class HTG_Group
    Private Const WS_EX_CLIENTEDGE = &H200
    Private Const WS_BORDER = &H800000
    Private gbBorderStyle As System.Windows.Forms.BorderStyle
    Private gbHeight As Integer
    Private gbWidth As Integer

    Private gbHeadFont As Font = New Font("Arial", 12, FontStyle.Bold, GraphicsUnit.Pixel)
    Private gbHeadLoc As Point = New Point(0, 0)
    Private gbHeadAlign As gbEAlign = gbEAlign.Left
    Private gbHeadForeCol As Color = Color.Red
    Private gbHeadBackCol As Color = Color.Beige
    Private gbHeadBorderStyle As System.Windows.Forms.BorderStyle
    Private gbHeadVis As gbEVis = gbEVis.True
    Private gbHeadText As String = "Testing"
    Private gbHeadShadow As gbEShadow = gbEShadow.True
    Private gbHeadShadowCol As Color = Color.Beige
    Private gbHeadShadowSpace As Short = 3
    Private gbHeadStrSize As New SizeF(gbWidth + 5, 30)
    Private gbSize As New SizeF(Me.width, Me.height)
    Private gbAddedControl As Control
    Private gbPrevLoc As Point = New Point(252, 3)
    Private gbPrevSize As New Size(23, 23)
    Private gbPrevVis As gbEVis = gbEVis.True

    Public Enum gbEShadow
        [True] = 0
        [False] = 1
    End Enum

    Public Enum gbEVis
        [True] = 0
        [False] = 1
    End Enum

    Public Enum gbEAlign As Short
        Left = 0
        Center = 1
        Right = 2

    End Enum

    Private Function gbRoundRect(ByVal gbX As Integer, ByVal gbY As Integer, ByVal gbWidth As Single, ByVal gbHeight As Single, _
        ByVal gbRadius As Integer, ByVal gbLineCol As Color, ByVal gbFillCol As Color, ByVal gbGraphics As System.Drawing.Graphics) As System.Drawing.Graphics


        Dim gbPen As New System.Drawing.Pen(gbLineCol, 5)
        Dim gbBrush As New System.Drawing.SolidBrush(gbFillCol)

        Dim gbPath As System.Drawing.Drawing2D.GraphicsPath = New System.Drawing.Drawing2D.GraphicsPath
        If gbRadius > gbWidth / 2 OrElse gbRadius > gbHeight / 2 Then gbRadius = gbHeight / 2

        gbPath.StartFigure()

        gbPath.AddArc(gbX, gbY, gbRadius * 2, gbRadius * 2, 180, 90)
        gbPath.AddArc(gbX + gbWidth - gbRadius * 2, gbY, gbRadius * 2, gbRadius * 2, 270, 90)
        gbPath.AddArc(gbX + gbWidth - gbRadius * 2, gbY + gbHeight - gbRadius * 2, gbRadius * 2, gbRadius * 2, 0, 90)
        gbPath.AddArc(gbX, gbY + gbHeight - gbRadius * 2, gbRadius * 2, gbRadius * 2, 90, 90)
        gbPath.CloseFigure()

        gbGraphics.FillPath(gbBrush, gbPath)
        gbGraphics.DrawPath(gbPen, gbPath)
        Me.Region = New Region(gbPath)
        Return gbGraphics

    End Function

    Private Function GetStringPath(ByVal s As String, ByVal dpi As Single, ByVal rect As RectangleF, ByVal font As Font, ByVal format As StringFormat) As GraphicsPath
        Dim path As GraphicsPath = New GraphicsPath()
        Dim emSize As Single = dpi * font.SizeInPoints / 72
        path.AddString(s, font.FontFamily, CInt(font.Style), emSize, rect, format)
        Return path
    End Function

    Protected Overrides ReadOnly Property CreateParams() As System.Windows.Forms.CreateParams
        Get
            Dim gbParam As System.Windows.Forms.CreateParams = MyBase.CreateParams

            gbParam.ExStyle = gbParam.ExStyle And (Not WS_EX_CLIENTEDGE)
            gbParam.Style = gbParam.Style And (Not WS_BORDER)

            Select Case BorderStyle
                Case BorderStyle.Fixed3D
                    gbParam.ExStyle = gbParam.ExStyle Or WS_EX_CLIENTEDGE
                Case BorderStyle.FixedSingle
                    gbParam.Style = gbParam.Style Or WS_BORDER
            End Select

            Return gbParam
        End Get
    End Property

    Public Property BorderStyle() As System.Windows.Forms.BorderStyle
        Get
            Return gbBorderStyle
        End Get

        Set(ByVal Value As System.Windows.Forms.BorderStyle)
            If (Not (gbBorderStyle = Value)) Then
                If (Not ([Enum].IsDefined(GetType(BorderStyle), Value))) Then
                    Throw New InvalidEnumArgumentException("value", CType(Value, Integer), GetType(BorderStyle))
                End If
                gbBorderStyle = Value
                UpdateStyles()
            End If
        End Set
    End Property

    Public Property HeadFont() As Font
        Get
            Return gbHeadFont
        End Get
        Set(ByVal value As Font)
            gbHeadFont = value
            lblGBHead.Font = gbHeadFont
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadLocation() As Point
        Get
            Return gbHeadLoc
        End Get
        Set(ByVal value As Point)
            gbHeadLoc = value
            lblGBHead.Location = New Point(value)
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadAlign() As gbEAlign
        Get
            Return gbHeadAlign
        End Get
        Set(ByVal value As gbEAlign)
            gbHeadAlign = value
            lblGBHead.Location = New Point(0, 0)
            lblGBHead.Invalidate()

        End Set
    End Property

    Public Property HeadForeColour() As Color
        Get
            Return gbHeadForeCol
        End Get
        Set(ByVal value As Color)
            gbHeadForeCol = value
            lblGBHead.ForeColor = gbHeadForeCol
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadBackColour() As Color
        Get
            Return gbHeadBackCol
        End Get
        Set(ByVal value As Color)
            gbHeadBackCol = value
            lblGBHead.BackColor = gbHeadBackCol
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadBorderStyle() As System.Windows.Forms.BorderStyle
        Get
            Return gbHeadBorderStyle
        End Get
        Set(ByVal value As System.Windows.Forms.BorderStyle)
            gbHeadBorderStyle = value
            lblGBHead.BorderStyle = gbHeadBorderStyle
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadVisible() As gbEVis
        Get
            Return gbHeadVis
        End Get
        Set(ByVal value As gbEVis)
            gbHeadVis = value
            Select Case gbHeadVis
                Case 0
                    lblGBHead.Visible = True
                Case 1
                    lblGBHead.Visible = False
            End Select
        End Set
    End Property

    Public Property HeadText() As String
        Get
            Return gbHeadText
        End Get
        Set(ByVal value As String)
            gbHeadText = value
            lblGBHead.Invalidate()

        End Set
    End Property

    Public Property HeadShadow() As gbEShadow
        Get
            Return gbHeadShadow
        End Get
        Set(ByVal value As gbEShadow)
            gbHeadShadow = value
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadShadowColour() As Color
        Get
            Return gbHeadShadowCol
        End Get
        Set(ByVal value As Color)
            gbHeadShadowCol = value
            lblGBHead.Invalidate()
        End Set
    End Property

    Public Property HeadShadowSpacing() As Short
        Get
            Return gbHeadShadowSpace
        End Get
        Set(ByVal value As Short)
            gbHeadShadowSpace = value
            lblGBHead.Invalidate()
        End Set
    End Property


    Private Sub HTG_Group_ControlAdded(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlAdded
        tmrGB.Enabled = True
        e.Control.BringToFront()
        AddHandler e.Control.Move, AddressOf MoveAddedControl
        gbAddedControl = e.Control

    End Sub

    Private Sub MoveAddedControl(ByVal sender As Object, ByVal e As System.EventArgs)
        If gbAddedControl.Top <= lblGBHead.Bottom Then gbAddedControl.Top = (lblGBHead.Top + gbAddedControl.Top) + 10
        If gbAddedControl.Left <= 0 Then gbAddedControl.Left = 1
    End Sub

    Private Sub HTG_Group_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        gbWidth = Me.Width
        gbHeight = Me.Height
        lblGBHead.Width = gbWidth
        If Me.Width < gbHeadStrSize.Width Then
            Me.Width = gbHeadStrSize.Width + 2
        End If

        If Me.Height < gbHeadStrSize.Height Then
            Me.Height = gbSize.Height
        End If
        Dim gbGraphics As Graphics
        gbGraphics = Graphics.FromHwnd(Me.Handle)

        gbRoundRect(0, 0, gbWidth, gbHeight, 15, Color.Black, Color.Transparent, gbGraphics)
        Me.Invalidate()
    End Sub

    Private Sub lblGBHead_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles lblGBHead.Paint
        If lblGBHead.BackColor <> gbHeadBackCol Then
            Me.HeadBackColour = gbHeadBackCol
        End If
        If gbHeadText <> String.Empty Then gbHeadStrSize = e.Graphics.MeasureString(gbHeadText, gbHeadFont)

        If gbHeadShadow = gbEShadow.True Then
            Dim gbShadowBrush As New SolidBrush(gbHeadShadowCol)
            Dim gbHeadBrush As New SolidBrush(gbHeadForeCol)
            Dim gbAlign As New System.Drawing.StringFormat

            Select Case gbHeadAlign
                Case gbEAlign.Left
                    gbAlign.Alignment = StringAlignment.Near
                Case gbEAlign.Center
                    gbAlign.Alignment = StringAlignment.Center
                Case gbEAlign.Right
                    gbAlign.Alignment = StringAlignment.Far
            End Select
            Dim gGB As Graphics = e.Graphics
            Dim gbSize As SizeF = New SizeF(Me.ClientRectangle.Width - gbHeadShadowSpace, Me.ClientRectangle.Height - gbHeadShadowSpace)

            Dim gbRect As RectangleF = New RectangleF(0, 0, gbSize.Width, gbSize.Height)

            Dim gbpShadow As GraphicsPath = GetStringPath(gbHeadText, gGB.DpiY, New RectangleF(gbHeadShadowSpace, gbHeadShadowSpace, gbSize.Width, gbSize.Height), gbHeadFont, gbAlign)
            Dim gbpLabel As GraphicsPath = GetStringPath(gbHeadText, gGB.DpiY, gbRect, gbHeadFont, gbAlign)

            gGB.FillPath(gbShadowBrush, gbpShadow)
            gGB.FillPath(gbHeadBrush, gbpLabel)
        Else
            Dim gbHeadBrush As New SolidBrush(gbHeadForeCol)
            Dim gbAlign As New System.Drawing.StringFormat

            Select Case gbHeadAlign
                Case gbEAlign.Left
                    gbAlign.Alignment = StringAlignment.Near
                Case gbEAlign.Center
                    gbAlign.Alignment = StringAlignment.Center
                Case gbEAlign.Right
                    gbAlign.Alignment = StringAlignment.Far
            End Select
            Dim gGB As Graphics = e.Graphics
            Dim gbSize As SizeF = New SizeF(Me.ClientRectangle.Width - gbHeadShadowSpace, Me.ClientRectangle.Height - gbHeadShadowSpace)

            Dim gbRect As RectangleF = New RectangleF(0, 0, gbSize.Width, gbSize.Height)

            Dim gbpLabel As GraphicsPath = GetStringPath(gbHeadText, gGB.DpiY, gbRect, gbHeadFont, gbAlign)

            gGB.FillPath(gbHeadBrush, gbpLabel)
        End If
    End Sub

    Private Sub tmrGB_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrGB.Tick
        If gbAddedControl.Top <= lblGBHead.Bottom Then gbAddedControl.Top = (lblGBHead.Top + gbAddedControl.Top) + 10
        If gbAddedControl.Left <= 0 Then gbAddedControl.Left = 1
        tmrGB.Enabled = False
    End Sub

 
End Class
